#include <iostream>
#include <queue>
#include <vector>
#include <cctype>
 
 using namespace std;
 
 int matrix[250][250];
 int kapu_kov = 0;
 int mego[255];
 
const int kapu_off = 1000;
  
struct Koord
{
	int x, y;
	Koord( int x, int y )
		: x(x), y(y)
	{
	}
};

enum Muvelet
{
	mXor, mAdd, mOr
};

struct SorElem
{
	Koord honnan;
	Koord hol;
	int jel;
	
	SorElem(): honnan(Koord(-1, -1)) {
	}
	
	SorElem(Koord h, Koord hol, int j): honnan(h), hol(hol), jel(j) {
	}
};
	
queue<SorElem> sor;
 
struct Kapu
{
	
	Muvelet tipus;
	Koord ki;
	bool ki_neg;
	
	std::vector<int> inputs;
	
	int fanin;
	
	Kapu()
	: fanin(0)
	{
	}	
};

std::vector<Kapu> kapuk;
 
 
void kapu( int x, int y )
{
	kapuk.push_back(Kapu());
	
	while( matrix[y][x+1] != '#' && matrix[y][x-1] != '#' )
	{
		--y;
	}
	
	int xend;	
	for( xend=x; matrix[y][xend+1] == '#'; ) ++xend;
	
	int yend;	
	for( yend=y; matrix[yend+1][xend] == '#'; ) ++yend;
	
	int xbegin;	
	for( xbegin=x; matrix[y][xbegin-1] == '#'; ) --xbegin;
		
	for( int ty = y; matrix[ty][xbegin] == '#'; ++ty )
	{
		matrix[ty][xbegin] = kapu_off + kapu_kov;
		if( matrix[ty][xbegin-1] == '=' || matrix[ty][xbegin-1] == 'o' )
			++kapuk.back().fanin;
	}
	
	for( int ty = y; matrix[ty][xend] == '#'; ++ty )
	{
		matrix[ty][xend] = kapu_off + kapu_kov;
		if( matrix[ty][xend+1] == '=' )
		{
			kapuk.back().ki = Koord( ty, xend+1 );
			kapuk.back().ki_neg = false;
		}
		else if( matrix[ty][xend+1] == 'o' )		
		{
			kapuk.back().ki = Koord( ty, xend+1 );
			kapuk.back().ki_neg = true;
		}
	}
	
	bool foundtype=false;
	for( int i=xbeg+1;!foundtype && i<xend;++i )
	{
		for( int j=y+1; j<yend; ++j )
		{
			if( matrix[j][i] != ' ' )
			{
				switch( matrix[j][i] )
				{
					case '&':						
						kapuk.back().tipus = mAnd;
						break;
					case '=':
						kapuk.back().tipus = mXor;
						break;
					case '1':
						matrix[j][i]='e';
						kapuk.back().tipus = mOr;
						break;
				}
			}
		}
	}
	
	for( int i=xbeg;i<=xend;++i )	
	{
		matrix[y][i] = 'e';
		matrix[yend][i] = 'e';
	}
	
	++kapu_kov;	
}
 
void bejar() {
	SorElem akt;
	
	while(!sor.empty()) {
		akt=sor.front();
		sor.pop();
		
		if( akt.hol.x < 0 || akt.hol.y < 0 )
			continue;		
			
		int c=matrix[akt.hol.y][akt.hol.x];
			
		matrix[akt.hol.y][akt.hol.x] = ' ';
		
		if(c==' ')
			continue;
			
		if(c=='o') {
			sor.push_back(SorElem(akt.hol, Koord(akt.hol.x+1, akt.hol.y)), 1-jel);
		}
		if(c=='=') {
			sor.push_back(SorElem(akt.hol, Koord(akt.hol.x+1, akt.hol.y)), jel);
		}
		
		if(c=='x' || c=='-' || c=='|' ) {
			int x=2*akt.hol.x-akt.honnan.x;
			int y=2*akt.hol.y-akt.honnan.y;
			sor.push_back(SorElem(akt.hol, Koord(x, y), jel);
		}

		if(c=='+') {
			int x, y;
			
			int n[4][2] = { 1,0,-1,0,0,1,0,-1 };
			char nem[4] = { '|','|','-','-' };
			
			for( int i=0;i<4;++i)
			{
				x=akt.hol.x + n[i][0];
				y=akt.hol.y + n[i][1];
			
				if( matrix[y][x] != nem[i] )
				{
					sor.push_back(SorElem(akt.hol, Koord(x, y), jel);	
				}		
			}	
			//if((x!=akt.honnan.x || y!=akt.honnan.y) && (matrix[y][x]!='|'))			
		}
		
		if( isupper(c) )
		{
			mego[c] = akt.jel;
		}
		
		if( c >= kapu_off )
		{
			int n = c-kapu_off;
			Kapu& ez = kapuk[n];
			
			ez.inputs.push_back( akt.jel );
			
			if( ez.fanin == ez.inputs.size() )
			{
				bool ertek;
				
				if( ez.muv == mAdd )
				{
					ertek = true;
					for( int k=0;k<ez.inputs.size();++k)
						ertek &= ez.inputs[k];				
				}
				
				else if( ez.muv == mOr )					
				{
					ertek = false;
					for( int k=0;k<ez.inputs.size();++k)
						ertek |= ez.inputs[k];				
				}
				
				else if( ez.muv == mXor )
				{
					ertek = false;
					for( int k=0;k<ez.inputs.size();++k)
						ertek ^= ez.inputs[k];				
				}
				
				sor.push_back(SorElem(akt.hol, Koord(x, y), ertek);
			}
		}
	
	}
}

 int main()
 {	 
	 for( ;; )
	 {		
		int width=0, height=0;
		int i, j;
		for( i=0;i<250;++i )
		{
			for( j=0;j<250;++j )			 
			{
				matrix[i][j] = ' ';
			}
		}
		 for( i=0;i<200;++i )
		 {
			 char sor[250];
			 fgets( sor, 240, stdin );
			 
			 int len = strlen(sor);
			 --len;
			 
			 if( len == 0 )
				 continue;
			 
			 int j;
			 for( j=0;j<len;++j )			 
			 {
				 if( sor[j] != '*')
					break;
			 }
			 
			 if( j == len )
			 {
				 if( i == 0 )
					 return 0;
				 else
					 break;
			 }
			 
			 if( (len+2) > width ) width = len+2;
			 
			 for( j=0;j<len;++j )			 
			 {
				matrix[i+1][j+1] = sor[j];
			 }
		}
		
		height = i+2;
		printf("hsdgs");

		for( int i=0;i<255; ++i )
		{
			mego[i] = 100;
		}
		 
		 /// Find gates 
		 for( i=0;i<height;++i )
		 {
			for( j=0;j<width;++j )
			{
				if( matrix[i][j] == '#' )
				{
					kapu(i,j);
				}
				
				if(matrix[i][j]== '1') {
					matrix[i][j]=' ';
					sor.push_back(SorElem(Koord(-1, -1), Koord(i, j), 1));

				if(matrix[i][j]== '0') {
					matrix[i][j]=' ';
					sor.push_back(SorElem(Koord(-1, -1), Koord(i, j), 0));

					}
			}
			//printf("\n");
		 }
		
		 for( int i=0;i<255; ++i )
		{
			if( mego[i] != 100 )
			{
				printf("%c=%d\n",i,mego[i]);
			}
			printf("\n");
		}
		 
			 
	 }
	 
	
	 return 0;
 }